<template>
    <div>
        <el-dialog
            :visible="!isLogged"
            :close-on-click-modal="false"
            :close-on-press-escape="false"
            :show-close="false"
            :title="$t('login.title')">
            <el-form
                v-if="!loading"
                label-position="left"
                label-width="100px">
                <el-form-item>
                    <span slot="label">{{$t('login.username.label')}}</span>
                    <el-input
                        v-bind:placeholder="$t('login.username.placeholder')"
                        v-model="username"
                        @keyup.enter.native="enterPressed"
                        ref="username"></el-input>
                </el-form-item>
                <el-form-item>
                    <span slot="label">{{$t('login.password.label')}}</span>
                    <el-input
                        v-bind:label="$t('login.password.label')"
                        v-bind:placeholder="$t('login.password.placeholder')"
                        v-model="password"
                        type="password"
                        @keyup.enter.native="enterPressed"
                        ref="password"></el-input>
                </el-form-item>
                <el-form-item>
                    <el-button @click="enterPressed">{{ $t("login.login.label") }}</el-button>
                </el-form-item>
            </el-form>
            <loading v-else></loading>
        </el-dialog>
    </div>
</template>
<script>
"use strict";

import Loading from "./../layout/loading.vue";

export default {
    name: "LoginForm",
    components: {Loading},
    data() {
        return {
            username: "",
            password: "",
            loginData: {
                resolve: null,
                reject: null
            },
            loading: false
        };
    },
    computed: {
        isLogged() {
            return this.$store.getters.isLogged;
        }
    },
    methods: {
        enterPressed() {
            if (this.username === "") {
                this.$refs.username.focus();
            } else if (this.password === "") {
                this.$refs.password.focus();
            } else {
                this.login();
            }
        },
        async login() {
            try {
                this.loading = true;
                await this.$store.dispatch("login", {
                    username: this.username,
                    password: this.password
                });
                this.username = "";
                this.password = "";
            } catch (cantLogin) {
                this.$notify({
                    title: this.$t("login.notifications.loginFail.title"),
                    message: this.$t("login.notifications.loginFail.content"),
                    type: "error"
                });
            }
            this.loading = false;
        }
    }
};
</script>
